Replaces customer context in cart - Fabric

Replaces customer context in cart

cURL

curl --request PUT \
  --url https://prod.cart.fabric.inc/v2/carts/{cartId}/customer \
  --header 'Authorization: <authorization>' \ 
  --header 'Content-Type: application/json' \
  --header 'x-site-context: <x-site-context>' \ 
  --data '
{
  "id": "d7e78a21-bee3-4448-bf1c-d5b5461dbda2",
  "type": "EMPLOYEE",
  "attributes": {
    "goldMember": [
      false
    ]
  },
  "segments": {
    "age": 23,
    "gender": "female"
  }
}
'

Python

import requests

url = "https://prod.cart.fabric.inc/v2/carts/{cartId}/customer"

payload = {
    "id": "d7e78a21-bee3-4448-bf1c-d5b5461dbda2",
    "type": "EMPLOYEE",
    "attributes": { "goldMember": [False] },
    "segments": {
        "age": 23,
        "gender": "female"
    }
}
headers = {
    "x-site-context": "<x-site-context>",
    "Authorization": "<authorization>",
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.text)

JavaScript (Fetch)

const options = {
  method: 'PUT',
  headers: {
    'x-site-context': '<x-site-context>',
    Authorization: '<authorization>',
    'Content-Type': 'application/json'
  },
  body: JSON.stringify({
    id: 'd7e78a21-bee3-4448-bf1c-d5b5461dbda2',
    type: 'EMPLOYEE',
    attributes: {goldMember: [false]},
    segments: {age: 23, gender: 'female'}
  })
};

fetch('https://prod.cart.fabric.inc/v2/carts/{cartId}/customer', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));

PHP

<?php

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://prod.cart.fabric.inc/v2/carts/{cartId}/customer",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "PUT",
  CURLOPT_POSTFIELDS => json_encode([
    'id' => 'd7e78a21-bee3-4448-bf1c-d5b5461dbda2',
    'type' => 'EMPLOYEE',
    'attributes' => [
      'goldMember' => [false]
    ],
    'segments' => [
      'age' => 23,
      'gender' => 'female'
    ]
  ]),
  CURLOPT_HTTPHEADER => [
    "Authorization: <authorization>",
    "Content-Type: application/json",
    "x-site-context: <x-site-context>"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}
?>

Go

package main

import (
    "fmt"
    "strings"
    "net/http"
    "io"
)

func main() {

url := "https://prod.cart.fabric.inc/v2/carts/{cartId}/customer"

payload := strings.NewReader("{\n  \"id\": \"d7e78a21-bee3-4448-bf1c-d5b5461dbda2\",\n  \"type\": \"EMPLOYEE\",\n  \"attributes\": {\n    \"goldMember\": [\n      false\n    ]\n  },\n  \"segments\": {\n    \"age\": 23,\n    \"gender\": \"female\"\n  }\n}")

req, _ := http.NewRequest("PUT", url, payload)

req.Header.Add("x-site-context", "<x-site-context>")
    req.Header.Add("Authorization", "<authorization>")
    req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
    body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))
}

Error Responses

{
  "code": "Bad Request",
  "message": "User ID or Cart ID does not exist"
}
{
  "code": "Cart or item not found",
  "message": "If the issue persists please contact support@fabric.inc."
}
{
  "code": "Internal Server Error",
  "message": "An internal error occurred. If the issue persists please contact support@fabric.inc."
}

Request Body Example

{
  "id": "d7e78a21-bee3-4448-bf1c-d5b5461dbda2",
  "type": "EMPLOYEE",
  "attributes": {
    "goldMember": [
      false
    ]
  },
  "segments": {
    "age": 23,
    "gender": "female"
  }
}